//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAF00DF02F1.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAF00DF02F1.cm

//## begin module%3DAF00DF02F1.cp preserve=no
//## end module%3DAF00DF02F1.cp

//## Module: PlotFoldmodel%3DAF00DF02F1; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotFoldmodel.cxx

//## begin module%3DAF00DF02F1.additionalIncludes preserve=no
//## end module%3DAF00DF02F1.additionalIncludes

//## begin module%3DAF00DF02F1.includes preserve=yes
#include <XSPlot/Plot/CreateBinnedPlotGroups.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>

//## end module%3DAF00DF02F1.includes

// PlotFoldmodel
#include <XSPlot/Commands/PlotFoldmodel.h>
//## begin module%3DAF00DF02F1.declarations preserve=no
//## end module%3DAF00DF02F1.declarations

//## begin module%3DAF00DF02F1.additionalDeclarations preserve=yes
//## end module%3DAF00DF02F1.additionalDeclarations


// Class PlotFoldmodel 

PlotFoldmodel::PlotFoldmodel()
  //## begin PlotFoldmodel::PlotFoldmodel%3DAEFC7D01AF_const.hasinit preserve=no
  //## end PlotFoldmodel::PlotFoldmodel%3DAEFC7D01AF_const.hasinit
  //## begin PlotFoldmodel::PlotFoldmodel%3DAEFC7D01AF_const.initialization preserve=yes
  : PlotCommand("foldmodel", new CreateBinnedPlotGroups(false, false))
  //## end PlotFoldmodel::PlotFoldmodel%3DAEFC7D01AF_const.initialization
{
  //## begin PlotFoldmodel::PlotFoldmodel%3DAEFC7D01AF_const.body preserve=yes
  isDataRequired(true);
  isActiveModelRequired(true);
  isDivisibleByArea(false);
  addCompLevel(2);
  isBackgroundApplicable(false);
  isLineIDApplicable(true);
  
  PlotAttributes styles;
  styles.symbolStyle = PlotStyle::BLANK;
  styles.lineStyle = PlotCommand::standardModelStyle();
  styles.lineStep = true;
  styles.lineWidth = 2;
  setStyleMap(PlotStyle::MODEL, styles);
  styles.lineStep = false;
  styles.lineStyle = PlotStyle::DOTTED;
  setStyleMap(PlotStyle::SOURCES, styles);
  
  //## end PlotFoldmodel::PlotFoldmodel%3DAEFC7D01AF_const.body
}


PlotFoldmodel::~PlotFoldmodel()
{
  //## begin PlotFoldmodel::~PlotFoldmodel%3DAEFC7D01AF_dest.body preserve=yes
  //## end PlotFoldmodel::~PlotFoldmodel%3DAEFC7D01AF_dest.body
}



//## Other Operations (implementation)
void PlotFoldmodel::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotFoldmodel::setRanges%4B2007B5035F.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
  
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   
   if (settings.xOption() == CHANNELS)
      rangeVals.xScaleType = PlotStyle::LINEAR;
   else 
      rangeVals.xScaleType = settings.xLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
   rangeVals.yScaleType = settings.yLog() ? PlotStyle::LOG : 
             PlotStyle::LINEAR;
   
   if (rangeVals.yScaleType == PlotStyle::LOG)
   {
      // Let plotting package determine y ranges
      rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
   }
   else
   {
      // Plotting package determines upper y
      rangeVals.ranges.y1 = 0.0;
      rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX
                        + PlotStyle::YMIN;
   }
  //## end PlotFoldmodel::setRanges%4B2007B5035F.body
}

void PlotFoldmodel::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotFoldmodel::makeLabels%4B2007BA03AB.body preserve=yes
   string xKey(settings.makeXOptionDependentLabel(labels.x));
   string yKey(string("y:data") + xKey.substr(1));
   string yLabel = settings.lookupLabelName(yKey);
   settings.insertUnitLabel(yLabel, true); 
   labels.y = yLabel;
   labels.title = settings.lookupLabelName("t:foldmodel");  
   
  //## end PlotFoldmodel::makeLabels%4B2007BA03AB.body
}

// Additional Declarations
  //## begin PlotFoldmodel%3DAEFC7D01AF.declarations preserve=yes
  //## end PlotFoldmodel%3DAEFC7D01AF.declarations

//## begin module%3DAF00DF02F1.epilog preserve=yes
//## end module%3DAF00DF02F1.epilog
